#include "islands.h"
#include <bits/stdc++.h>

using namespace std;

const int nmax=1e4+42;

std::vector<std::vector<int>> ask(const std::vector<std::vector<int>> &partition);

vector<int> common(vector<int> a,vector<int> b)
{
    for(auto w:b)a.push_back(w);

    sort(a.begin(),a.end());

    vector<int> ret={};
    for(int i=1;i<a.size();i++)
        if(a[i-1]==a[i])ret.push_back(a[i]);

    return ret;
}
bool cmp(vector<int> a,vector<int> b)
{
    return a.size()<b.size();
}

vector<int> seen[nmax];

std::vector<int> solve(int N)
{
    int n=N;

    vector<int> outp(n,0);

    vector< vector<int> > q={};

    int SZ=0;
    int on=0;

    for(int i=0;i<N;i++)
    {
        if(SZ==on)
        {
            q.push_back({});
            SZ++;
            on=0;
        }

        q[SZ-1].push_back(i);
        on++;
    }

    if(q[SZ-2].size()>=q[SZ-1].size())
    {
        for(auto w:q[SZ-1])
            q[SZ-2].push_back(w);

        q.pop_back();
    }

    /*
    for(auto p:q)
    {
        cout<<"p: ";for(auto w:p)cout<<w<<" ";
        cout<<endl;
    }
    */

    vector< vector<int> > ret=ask(q);

    sort(ret.begin(),ret.end(),cmp);

    for(int i=0;i<q.size();i++)
    {
        for(auto w:q[i])seen[w]=ret[i];
    }

    /*
    cout<<"seen: ";
    for(int i=0;i<N;i++)
    {
        cout<<i<<" -> ";for(auto w:seen[i])cout<<w<<" ";cout<<endl;
    }
    */

    vector< vector<int> > other_q={};
    for(int i=0;i<ret.size();i++)
    {
        other_q.push_back({});
    }

    for(int i=0;i<q.size();i++)
    {
        for(int j=0;j<q[i].size();j++)
            if(i>j)other_q[j].push_back(q[i][j]);
            else other_q[q.size()-1].push_back(q[i][j]);
    }

    sort(other_q.begin(),other_q.end(),cmp);

    ret=ask(other_q);
    sort(ret.begin(),ret.end(),cmp);

    for(int i=0;i<other_q.size();i++)
    {
        for(auto w:other_q[i])seen[w]=common(seen[w],ret[i]);
    }

    vector<int> known={},unknown={};

    vector<int> solved(n,0);

    vector<int> inv(n,-1);

    for(int i=0;i<N;i++)
        if(seen[i].size()==1)
        {
            outp[i]=seen[i][0];

            //cout<<i<<" -> "<<seen[i][0]<<endl;

            known.push_back(i);

            solved[i]=1;

            inv[seen[i][0]]=i;
        }
        else unknown.push_back(i);

    if(unknown.size()==0)return outp;

    vector<int> group(n,0);

    vector< vector<int> > last_q={};
    for(int i=0;i<unknown.size()&&i<known.size();i++)
    {
        last_q.push_back({unknown[i],known[i]});
        group[unknown[i]]=known[i];
        group[known[i]]=unknown[i];
    }

    vector<int> remain={};

    for(int i=min(known.size(),unknown.size());i<unknown.size()||i<known.size();i++)
    {
        if(i<known.size())remain.push_back(known[i]);
        if(i<unknown.size())remain.push_back(unknown[i]);
    }

    if(remain.size())
    {
        last_q.push_back(remain);
    }

    sort(last_q.begin(),last_q.end(),cmp);

    /*
    cout<<"last_q: "<<endl;
    for(auto p:last_q)
    {
        cout<<"p: ";for(auto w:p)cout<<w<<" ";
        cout<<endl;
    }
    */

    ret=ask(last_q);

    sort(ret.begin(),ret.end(),cmp);

    /*
    cout<<"ret: "<<endl;
    for(auto p:ret)
    {
        cout<<"ret: ";for(auto w:p)cout<<w<<" ";
        cout<<endl;
    }
    */

    for(auto w:ret)
    {
        if(w.size()==1)
        {
            outp[last_q[0][0]]=w[0];
            continue;
        }
        else if(w.size()==2)
        {
            //one of them is known
            int p=inv[w[0]];
            int q=inv[w[1]];

            if(p>=0&&q>=0)continue;

            if(p==-1)swap(p,q);

            //cout<<"p= "<<p<<" q= "<<q<<endl;

            outp[group[p]]=w[0]+w[1]-outp[p];
        }
    }

    return outp;
}
/*
namespace {
using namespace std;

const int NMAX = 10000;
const int QMAX = 2 * NMAX;

int N;
int queries = 0, max_size = 0;
vector<int> real_perm;

void readTest() {
  assert(fscanf(stdin, "%d", &N) == 1);
  real_perm.resize(N);
  for (int &x : real_perm) {
    assert(fscanf(stdin, "%d", &x) == 1);
  }
}

void process_partition(vector<vector<int>> &query_partition) {
  static mt19937 mt(
      chrono::high_resolution_clock::now().time_since_epoch().count() ^ 666013 ^
      1000000007 ^ 23);
  shuffle(query_partition.begin(), query_partition.end(), mt);
  for (vector<int> &v : query_partition) {
    shuffle(v.begin(), v.end(), mt);
    for (int &x : v) {
      x = real_perm[x];
    }
  }
}

} // namespace

vector<vector<int>> ask(const vector<vector<int>> &partition) {
  // Check partition.
  ++queries;
  max_size = max(max_size, (int) partition.size());
  vector<bool> vis(N, false);
  bool ok = true;
  int cnt_vals = 0;
  for (int i = 0; i < static_cast<int>(partition.size()) && ok; ++i) {
    if (partition[i].empty()) {
      ok = false;
    }
    for (int j = 0; j < static_cast<int>(partition[i].size()) && ok; ++j) {
      const int val = partition[i][j];
      if (val < 0 || val >= N || vis[val]) {
        ok = false;
      }
      vis[val] = true;
      ++cnt_vals;
    }
  }
  if (cnt_vals < N) {
    ok = false;
  }
  if (!ok) {
    std::cout << "Bad query." << std::endl;
    exit(0);
  }
  vector<vector<int>> cp_partition(partition);
  process_partition(cp_partition);
  return cp_partition;
}

int main() {
  readTest();
  const vector<int> sol_contestant = solve(N);

  std::cout << "Your program guessed:" << std::endl;

  for (int num : sol_contestant)
  {
    std::cout << num << " ";
  }

  std::cout << "Queries: " << queries << "\nMax size: " << max_size << std::endl;

  return 0;
}
*/
