#include "ctree.h"
#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42;

int n;
vector<int> adj[nmax];

int SZ[nmax];

void dfs_SZ(int node,int par)
{
    SZ[node]=1;
    for(auto w:adj[node])
        if(w!=par)
        {
            dfs_SZ(w,node);
            SZ[node]+=SZ[w];
        }
}

vector<int> centroids;

void reroot(int from,int to)
{
    SZ[from]=n-SZ[to];
    SZ[to]=n;
}
void gen(int node,int par)
{
    bool ok=1;
    for(auto w:adj[node])
        if(SZ[w]<SZ[node])
        {
            if(SZ[w]>n/2)ok=0;
        }
        else
        {
            if(n-SZ[node]>n/2)ok=0;
        }

    if(ok)centroids.push_back(node);

    for(auto w:adj[node])
        if(w!=par)
        {
            reroot(node,w);

            gen(w,node);

            reroot(w,node);
        }
}
void get_centroids()
{
    centroids={};

    dfs_SZ(0,0);

    gen(0,0);

    //cout<<"centroids: ";for(auto w:centroids)cout<<w<<" ";cout<<endl;
}

int up[20][nmax];
int depth[nmax];

void dfs_up(int node,int par,int d)
{
    depth[node]=d;

    up[0][node]=par;
    for(int j=1;j<20;j++)up[j][node]=up[j-1][up[j-1][node]];

    for(auto w:adj[node])
        if(w!=par)
            dfs_up(w,node,d+1);
}

int lca(int u,int v)
{
    if(depth[u]<depth[v])swap(u,v);

    for(int i=19;i>=0;i--)
        if(depth[u]-(1<<i)>=depth[v])u=up[i][u];

    if(u==v)return u;

    for(int i=19;i>=0;i--)
        if(up[i][u]!=up[i][v])u=up[i][u],v=up[i][v];

    return up[0][u];
}

vector< pair<int,int> > children[2];

bool cmp(pair<int,int> a,pair<int,int> b)
{
    return a.first>b.first;
}
void gen_children(int id)
{
    children[id]={};

    int node=centroids[id];

    dfs_SZ(node,node);

    for(auto w:adj[node])
        children[id].push_back({SZ[w],w});

    sort(children[id].begin(),children[id].end(),cmp);

    //cout<<id<<" -> "<<centroids[id]<<" : ";for(auto w:children[id])cout<<w.first<<" "<<w.second<<"\t";cout<<endl;
}






int cut(int id,int me,int blocked)
{
    //cout<<"cut "<<id<<" "<<me<<" "<<blocked<<endl;

    int ret=0;

    for(auto w:children[id])
        if(w.second!=blocked)
        {
            ret++;
            me=me-w.first;
            if(me<=n/2)return ret;
        }

    return 1e9;
}

int dist(int p,int q)
{
    return depth[p]+depth[q]-2*depth[lca(p,q)];
}

int first_on_path(int p,int q)
{
    int l=lca(p,q);

    //cout<<"first_on_path "<<p<<" "<<q<<" "<<l<<endl;

    if(p!=l)return up[0][p];

    for(int i=19;i>=0;i--)
        if(depth[up[i][q]]>depth[p])q=up[i][q];

    return q;
}

int SZ_if(int node,int new_root)
{
    if(depth[node]>depth[new_root])return SZ[node];
    return n-SZ[new_root];
}
int eval(int node)
{
    int nearest=0;

    if(centroids.size()==2)
    {
        if(dist(node,centroids[0])>dist(node,centroids[1]))nearest=1;
    }

    int subtree_size=-1;

    int node_other=centroids[nearest];

    if(node==node_other)return 0;

    int subroot=first_on_path(node,node_other);

    int blocked=first_on_path(node_other,node);

    //cout<<node<<" -> "<<node_other<<" subroot= "<<subroot<<" blocked= "<<blocked<<endl;

    //cout<<"children: ";for(auto w:children)cout<<w<<" ";cout<<endl;

    return min(1+cut(nearest,SZ_if(node_other,blocked),blocked),cut(nearest,SZ_if(subroot,node),blocked));
}







std::vector<int> solve(int N, std::vector<int> X, std::vector<int> Y)
{
    n=N;
    for(int i=0;i<n;i++)adj[i]={};

    for(int i=0;i<n-1;i++)
    {
        adj[X[i]].push_back(Y[i]);
        adj[Y[i]].push_back(X[i]);
    }

    get_centroids();

    for(int i=0;i<centroids.size();i++)
        gen_children(i);

    dfs_up(0,0,0);

    dfs_SZ(0,0);

    vector<int> outp={};
    for(int i=0;i<n;i++)
        outp.push_back(eval(i));

    return outp;
}
/*
int main(){
    int N, T;
    std::cin >> T;
    for(int t = 1; t <= T; t++) {
        std::cin >> N;
        std::vector<int> X(N - 1), Y(N - 1);
        for (int i = 0; i < N - 1; i++) {
            std::cin >> X[i] >> Y[i];
        }
        std::vector<int> answers = solve(N, X, Y);
        for (auto answer: answers)
            std::cout << answer << ' ';
        std::cout << '\n';
    }
    return 0;
}
*/
