#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define all(x) (x).begin(), (x).end()
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();

const int N = 3e5;

int n, sz[N], pos[N];
vector<int> ans, pref;
vector<int> adj[N];

void build_ans(int u, int p, int anc){
    int idx = pos[anc];

    int l = -1, r = (int)pref.size() - 1;
    while(l != r){
        int mid = (l + r) >> 1;
        int sum;
        if(mid == -1){
            sum = sz[u];
        }
        else{
            sum = pref[mid];
            if(mid >= idx) sum -= sz[anc];
            sum += sz[u];
        }

        if(sum >= (n >> 1) + (n & 1))
            r = mid;
        else l = mid + 1;
    }
    ans[u] = (l + 1) - (l >= idx);
    check_min(ans[u], ans[anc] + 1);

    for(int to: adj[u])
        if(to != p)
            build_ans(to, u, anc);
}

void sz_dfs(int u, int p = -1){
    sz[u] = 1;
    for(int to: adj[u])
        if(to != p){
            sz_dfs(to, u);
            sz[u] += sz[to];
        }
}

int get_centroid(int u, int p = -1){
    for(int to: adj[u])
        if(to != p && sz[to] > n / 2)
            return get_centroid(to, u);
    return u;
}

vector<int> solve(int _n, vector<int> x, vector<int> y){
    n = _n;
    ans.clear();
    fill(sz, sz + n, 0);
    for(int i = 0; i < n; ++i)
        adj[i].clear();
    pref.clear();

    for(int i = 0; i < n - 1; ++i){
        adj[x[i]].push_back(y[i]);
        adj[y[i]].push_back(x[i]);
    }
    ans.resize(n, 0);

    sz_dfs(0);
    int centroid = get_centroid(0);
    sz_dfs(centroid);

    sort(adj[centroid].begin(), adj[centroid].end(), [&](int l, int r){
        return sz[l] > sz[r];
    });

    int curr = 0;
    for(int to: adj[centroid]){
        curr += sz[to];
        pref.push_back(curr);
        pos[to] = pref.size() - 1;
    }

    for(int to: adj[centroid])
        build_ans(to, centroid, to);

    return ans;
}
