#include <bits/stdc++.h>

namespace {
using namespace std;

const int NMAX = 10000;
const int QMAX = 2 * NMAX;

int N;
int queries = 0, max_size = 0;
vector<int> real_perm;

void process_partition(vector<vector<int>> &query_partition) {
  static mt19937 mt(
      chrono::high_resolution_clock::now().time_since_epoch().count() ^ 666013 ^
      1000000007 ^ 23);
  shuffle(query_partition.begin(), query_partition.end(), mt);
  for (vector<int> &v : query_partition) {
    shuffle(v.begin(), v.end(), mt);
    for (int &x : v) {
      x = real_perm[x];
    }
  }
}

} // namespace

vector<vector<int>> ask(const vector<vector<int>> &partition) {
  // Check partition.
  ++queries;
  max_size = max(max_size, (int) partition.size());
  vector<bool> vis(N, false);
  bool ok = true;
  int cnt_vals = 0;
  for (int i = 0; i < static_cast<int>(partition.size()) && ok; ++i) {
    if (partition[i].empty()) {
      ok = false;
    }
    for (int j = 0; j < static_cast<int>(partition[i].size()) && ok; ++j) {
      const int val = partition[i][j];
      if (val < 0 || val >= N || vis[val]) {
        ok = false;
      }
      vis[val] = true;
      ++cnt_vals;
    }
  }
  if (cnt_vals < N) {
    ok = false;
  }
  if (!ok) {
    std::cout << "Bad query." << std::endl;
    exit(0);
  }
  vector<vector<int>> cp_partition(partition);
  process_partition(cp_partition);
  return cp_partition;
}

const int maxn = 1e4 + 3;

const int K = 3;

int where[maxn][17];
vector <int> res;
int bt[maxn][17];

void f(vector <int> idx, vector <int> val, int bit)
{
    if (idx.empty())
        return;

    if ((int)idx.size() == 1)
    {
        if (val.empty())
        {
            cout << "wtf";
            exit(0);
        }
        res[idx[0]] = val[0];
        return;
    }

    vector <int> idx1, idx2, idx3, val1, val2, val3;
    for (auto i: idx)
    {
        if (bt[i][bit] == 0)
            idx1.push_back(i);

        else
            if (bt[i][bit] == 1)
            idx2.push_back(i);

        else
            idx3.push_back(i);
    }

    for (auto i: val)
    {
        if (where[i][bit] == 1)
            val1.push_back(i);

        else
            if (where[i][bit] == 2)
            val2.push_back(i);

        else
            val3.push_back(i);
    }

    f(idx1, val1, bit + 1);
    f(idx2, val2, bit + 1);
    f(idx3, val3, bit + 1);
}

vector <int> solve(int n)
{
    for (int i = 0; i < n; i++)
    {
        int idx = 0;
        int temp = i;

        while (temp)
        {
            bt[i][idx] = temp % K;
            temp /= K;
            idx++;
        }
    }

    int lg;
    res.resize(n);
    for (lg = 0; ; lg++)
    {
        vector <int> v1, v2, v3;
        for (int i = 0; i < n; i++)
        {
            if (bt[i][lg] == 0)
                v1.push_back(i);

            else
                if (bt[i][lg] == 1)
                v2.push_back(i);

            else
                v3.push_back(i);
        }

        vector <vector <int> > all;

        if ((int)v1.size() == n)
            break;

        int where_to = -1;
        if ((int)v1.size() == (int)v2.size())
        {
            all.push_back({v1.back()});
            v1.pop_back();
            where_to = 1;
        }

        else
            if ((int)v2.size() == (int)v3.size())
        {
            all.push_back({v2.back()});
            v2.pop_back();
            where_to = 2;
        }

        if (!v1.empty())
        all.push_back(v1);

        if (!v2.empty())
        all.push_back(v2);

        if (!v3.empty())
        all.push_back(v3);

        auto ans = ask(all);
        for (int i = 0; i < (int)ans.size(); i++)
        {
            if ((int)ans[i].size() == (int)v1.size())
            {
                for (auto j: ans[i])
                    where[j][lg] = 1;
            }

            else
                if ((int)ans[i].size() == (int)v2.size())
                for (auto j: ans[i])
                where[j][lg] = 2;

            else
                if ((int)ans[i].size() == (int)v3.size())
                for (auto j: ans[i])
                where[j][lg] = 3;

            else
            {
                for (auto j: ans[i])
                where[j][lg] = where_to;
            }
        }
    }

    vector <int> v;
    for (int i = 0; i < n; i++)
        v.push_back(i);

    f(v, v, 0);

    return res;
}



int main() {
  cin >> N;
  real_perm.resize(N);
  for (int i = 0; i < N; i++)
    cin >> real_perm[i];

  const vector<int> sol_contestant = solve(N);

  std::cout << "Your program guessed:" << std::endl;

  for (int num : sol_contestant)
  {
    std::cout << num << " ";
  }

  std::cout << "Queries: " << queries << "\nMax size: " << max_size << std::endl;

  return 0;
}
