#include <bits/stdc++.h>
#include "ctree.h"

using namespace std;

const int maxn = 3e5 + 3;

int sz[maxn], par[maxn];
vector <int> adj[maxn];

void pre_dfs(int ver)
{
    sz[ver] = 1;
    for (auto i: adj[ver])
        if (i != par[ver])
    {
        par[i] = ver;
        pre_dfs(i);
        sz[ver] += sz[i];
    }
}

int find_centroid(int ver, int all)
{
    for (auto i: adj[ver])
        if (sz[i] > all / 2 && i != par[ver])
        return find_centroid(i, all);

    return ver;
}

vector <int> solve(int n, vector <int> x, vector <int> y)
{
    for (int i = 0; i < n-1; i++)
        adj[i].clear();

    for (int i = 0; i < n-1; i++)
    {
        adj[x[i]].push_back(y[i]);
        adj[y[i]].push_back(x[i]);
    }

    vector <int> ans(n);
    for (int i = 0; i < n; i++)
    {
        par[i] = -1;
        pre_dfs(i);

        int centroid = find_centroid(i, n);
        int to_sub = 0, cnt = 0;
        while (centroid != i)
        {
            vector <int> v;
            for (auto j: adj[centroid])
                if (j != par[centroid])
                v.push_back(sz[j]);

            sort (v.begin(), v.end());
            reverse(v.begin(), v.end());

            int idx = 0;
            while (sz[centroid] - to_sub > n / 2)
            {
                cnt++;
                to_sub += v[idx++];
            }

            sz[centroid] -= to_sub;
            centroid = par[centroid];
        }

        ans[i] = cnt;
    }

    return ans;
}

/*
int n;
vector <int> x, y;
int main()
{
    cin >> n;
    x.resize(n-1), y.resize(n-1);

    for (int i = 0; i < n-1; i++)
        cin >> x[i] >> y[i];

    for (auto i: solve(n, x, y))
        cout << i << " ";
    cout << endl;
}
*/
