#include <bits/stdc++.h>
#include "ctree.h"

using namespace std;

const int maxn = 3e5 + 3;

int sz[maxn], par[maxn];
vector <int> adj[maxn];
vector <int> ans;

void pre_dfs(int ver)
{
    sz[ver] = 1;
    for (auto i: adj[ver])
        if (i != par[ver])
        {
            par[i] = ver;
            pre_dfs(i);
            sz[ver] += sz[i];
        }
}

int find_centroid(int ver, int all)
{
    for (auto i: adj[ver])
        if (sz[i] > all / 2 && i != par[ver])
            return find_centroid(i, all);

    return ver;
}

void solve_dfs(int ver, int cnt, int to_sub, int all, int to_add)
{
    ans[ver] = cnt;
    vector <int> curr_adj;
    for (auto i: adj[ver])
        if (i != par[ver])
        curr_adj.push_back(i);

    for (auto i: curr_adj)
    {
        vector <int> v;
        for (auto j: curr_adj)
            if (i != j)
            v.push_back(sz[j]);

        if (to_add != -1)
            v.push_back(to_add);

        sort (v.begin(), v.end());
        reverse (v.begin(), v.end());

        int idx = 0, curr_to_sub = to_sub, curr_cnt = cnt;
        while (all - sz[i] - curr_to_sub > all / 2)
        {
            if (idx == (int)v.size())
            {
                cout << ver << " " << i << "wtf" << endl;
                exit(0);
            }

            curr_cnt++;
            curr_to_sub += v[idx++];
        }

        solve_dfs(i, curr_cnt, curr_to_sub, all, all - sz[i] - curr_to_sub);
    }
}

vector <int> solve(int n, vector <int> x, vector <int> y)
{
    for (int i = 0; i < n; i++)
        adj[i].clear();

    for (int i = 0; i < n-1; i++)
    {
        adj[x[i]].push_back(y[i]);
        adj[y[i]].push_back(x[i]);
    }

    ans.resize(n);
    par[0] = -1;
    pre_dfs(0);

    int centroid = find_centroid(0, n);
    par[centroid] = -1;
    pre_dfs(centroid);

    solve_dfs(centroid, 0, 0, n, -1);

    return ans;
}

/*
int n;
vector <int> x, y;
int main()
{
    cin >> n;
    x.resize(n-1), y.resize(n-1);

    for (int i = 0; i < n-1; i++)
        cin >> x[i] >> y[i];

    for (auto i: solve(n, x, y))
        cout << i << " ";
    cout << endl;
}
*/
