#include <bits/stdc++.h>
#include "ctree.h"

using namespace std;

const int maxn = 3e5 + 3;

int sz[maxn], par[maxn];
vector <int> adj[maxn];
vector <int> ans;

void pre_dfs(int ver)
{
    sz[ver] = 1;
    for (auto i: adj[ver])
        if (i != par[ver])
        {
            par[i] = ver;
            pre_dfs(i);
            sz[ver] += sz[i];
        }
}

int find_centroid(int ver, int all)
{
    for (auto i: adj[ver])
        if (sz[i] > all / 2 && i != par[ver])
            return find_centroid(i, all);

    return ver;
}

int pos[maxn];
void solve_dfs(int ver, int cnt, int to_sub, int all, int to_add)
{
    ans[ver] = cnt;
    vector <int> curr_adj;
    for (auto i: adj[ver])
        if (i != par[ver])
        curr_adj.push_back(i);

    vector <pair <int, int> > v;
    for (auto i: curr_adj)
        v.push_back({sz[i], i});

    if (to_add != -1)
        v.push_back({to_add, -1});

    sort (v.begin(), v.end());
    reverse (v.begin(), v.end());

    for (int i = 1; i <= (int)v.size(); i++)
        if (v[i-1].second != -1)
        pos[v[i-1].second] = i;

    vector <int> pr((int)v.size() + 1);
    pr[0] = 0;
    for (int i = 1; i <= (int)v.size(); i++)
        pr[i] = pr[i-1] + v[i-1].first;

    for (auto i: curr_adj)
    {
        int low = 0, high = (int)v.size();
        while (low < high)
        {
            int mid = (low + high) / 2;
            int curr = pr[mid];
            if (pos[i] <= mid)
                curr -= sz[i];

            if (all - sz[i] - to_sub - curr > all / 2)
                low = mid + 1;

            else
                high = mid;
        }

        int curr = pr[low], curr_cnt = cnt + low;
        if (pos[i] <= low)
            curr -= sz[i], curr_cnt--;

        solve_dfs(i, curr_cnt, to_sub + curr, all, all - sz[i] - to_sub - curr);
    }
}

vector <int> solve(int n, vector <int> x, vector <int> y)
{
    for (int i = 0; i < n; i++)
        adj[i].clear();

    for (int i = 0; i < n-1; i++)
    {
        adj[x[i]].push_back(y[i]);
        adj[y[i]].push_back(x[i]);
    }

    ans.resize(n);
    par[0] = -1;
    pre_dfs(0);

    int centroid = find_centroid(0, n);
    par[centroid] = -1;
    pre_dfs(centroid);

    solve_dfs(centroid, 0, 0, n, -1);

    return ans;
}

/*
int n;
vector <int> x, y;
int main()
{
    cin >> n;
    x.resize(n-1), y.resize(n-1);

    for (int i = 0; i < n-1; i++)
        cin >> x[i] >> y[i];

    for (auto i: solve(n, x, y))
        cout << i << " ";
    cout << endl;
}
*/
